package wdbpress.divetojava.examples.stringjoiner;

import java.util.Arrays;
import java.util.stream.Collectors;

import org.openjdk.jmh.annotations.Benchmark;
import org.openjdk.jmh.annotations.Fork;
import org.openjdk.jmh.annotations.Measurement;
import org.openjdk.jmh.annotations.Warmup;
import java.util.concurrent.TimeUnit;


public class StringJoinerExample{

  @Benchmark
  @Fork(value = 1, jvmArgs = {"-XX:+UnlockExperimentalVMOptions", "-XX:+UseEpsilonGC", "-Xmx1g"})
  //@Fork(value = 1, jvmArgs = {"-Xmx1g", "-Xlog:gc=info"})
  @Warmup(iterations = 0)
  @Measurement(iterations = 1, time = 10, timeUnit = TimeUnit.MILLISECONDS)
  public static void benchmark(){
    join("Dive", "to", "Java");
  }

  private static long getUsedMemory(){
    var runtime = Runtime.getRuntime();
    return runtime.totalMemory() - runtime.freeMemory();
  }

  public static String join(String... values){
    //var usedBefore = getUsedMemory();
    var result = Arrays.stream(values)
                       .collect(Collectors.joining(" "));
    //var consumption = getUsedMemory() - usedBefore;
    //System.out.println("Memory consumption: " + consumption + " bytes");

    return result;
  }

  public static void main(String[] args){
    System.out.println(join(args));
  }

}
